// color picker based on jasmine c. lee's sketch https://gist.github.com/jasmineclee/86236bc2bd16cb279b52

//-----SERIAL VARIABLES-----
var serial;
var portName = '/dev/cu.usbmodem1411';

//-----WINDOW DIMENSIONS-----
var windW = 900;
var windH = 600;

//-----Color Values-----
var colorLeft = 255;
var colorTop = 255;
var colorRight = 255;
var colorBottom = 255;

var personOneColor = 255;
var personTwoColor = 255;
var lightColor = 255;
var vibeColor = 255;

//-----button counts-----
var countLeft = 0;
var countTop = 0;
var countRight = 0;
var countBottom = 0;

var personOneClick = 0;
var personTwoClick = 0;
var lightClick = 0;
var vibeClick = 0;


//-----button selected-----
var buttonLeft = false;
var buttonTop = false;
var buttonRight = false;
var buttonBottom = false;

var personOne = false;
var personTwo = false;
var light = false;
var vibe = false;

//-----Icons & Images -----
var personOneImg , personTwoImg, lightImg, vibeImg;
var personOneImgW , personTwoImgW, lightImgW, vibeImgW;

var squares = [];
//------------------------

var latestData

var serialPortThree;

function preload() {
 // preload() runs once
  personOneImg = loadImage('assets/person.png');
  personTwoImg = loadImage('assets/person.png');
  lightImg = loadImage('assets/light.png');
  vibeImg = loadImage('assets/vibe.png');
  personOneImgW = loadImage('assets/person-w.png');
  personTwoImgW = loadImage('assets/person-w.png');
  lightImgW = loadImage('assets/light-w.png');
  vibeImgW = loadImage('assets/vibe-w.png');
}

function setup() {
  //-----Serial Setup-----
  serial = new p5.SerialPort();
  serial.on('list', printList);
  serial.on('connected', serverConnected);
  serial.on('open', portOpen);
  serial.on('data', gotData);
  serial.on('error', serialError);
  serial.on('close', portClose);

  serial.list();
  serial.open(portName);

  console.log("Port Name: " + portName);
  //----------------------

  createCanvas(windW, windH);
  smooth();
  background(240);


  // initial text at the top (where your color's RGB will be)
  push();
  textSize(25);
  textAlign(CENTER);
  noStroke();
  text("PATCH UI", windW / 2, 50);
  pop();

  // for (var i = 0; i < 4; i++) {
  //   squares.push(new Square());
  // }


}


function draw() {

    shapes();
    printImg();
}

function printImg(){
  image(personOneImg, 140,400);
  image(personTwoImg, 315,400);
  image(lightImg, 480,400);
  image(vibeImg, 645,400);
}

function shapes(){
  noStroke();

//----LEFT SMALL----
  fill(colorLeft);
  beginShape();
  vertex(220, 232);
  vertex(257, 195);
  vertex(319, 195);
  vertex(356, 232);
  vertex(319, 269);
  vertex(257, 269);
  endShape(CLOSE);

//----CENTER TOP----
  fill(colorTop);
  beginShape();
  vertex(330, 188);
  vertex(367, 151);
  vertex(533, 151);
  vertex(570, 188);
  vertex(533, 225);
  vertex(367, 225);
  endShape(CLOSE);

//----RIGHT SMALL----
  fill(colorRight);
  beginShape();
  vertex(544, 232);
  vertex(581, 195);
  vertex(643, 195);
  vertex(680, 232);
  vertex(643, 269);
  vertex(581, 269);
  endShape(CLOSE);

//----CENTER BOTTOM----
  fill(colorBottom);
  beginShape();
  vertex(330, 276);
  vertex(367, 239);
  vertex(533, 239);
  vertex(570, 276);
  vertex(533, 313);
  vertex(367, 313);
  endShape(CLOSE);

//----PERSON ONE----
  fill(personOneColor);
  rect(140, 400, 100, 100);
  textAlign(CENTER);
  textSize(16);
  noStroke();
  fill(0);
  text('Person One', 190, 525);


//----PERSON TWO----
  fill(personTwoColor);
  rect(315, 400, 100, 100);
  textAlign(CENTER);
  textSize(16);
  noStroke();
  fill(0);
  text('Person Two', 365, 525);

//----LIGHT----
  fill(lightColor);
  rect(480, 400, 100, 100);
  textAlign(CENTER);
  textSize(16);
  noStroke();
  fill(0);
  text('Light Notify', 530, 525);

//----VIBE----
  fill(vibeColor);
  rect(645, 400, 100, 100);
  textAlign(CENTER);
  textSize(16);
  noStroke();
  fill(0);
  text('Vibe Notify', 695, 525);

}


function mousePressed() {

  // this is to say: if you press on any part of the spectrum, you will make display the selected color at the rectangle AND fill in the rectangle at the bottom
  if (mouseX > 220 && mouseX < 356 && mouseY >195 && mouseY < 269) {
    countLeft++;
    if (countLeft % 2 == 1 && buttonTop == false && buttonRight == false && buttonBottom == false){
      colorLeft = 40;
      buttonLeft = true;
    } else if (countLeft % 2 == 0){
      colorLeft = 255;
      buttonLeft = false;
      countRight = 0;
      countTop = 0;
      countBottom = 0;
    }
    console.log("left pressed " + countLeft);
  }

  if (mouseX > 330 && mouseX < 570 && mouseY >151 && mouseY < 225) {
    countTop++;
    if (countTop % 2 == 1 && buttonBottom == false && buttonRight == false && buttonLeft == false){
      colorTop = 40;
      buttonTop = true;
    } else if (countTop % 2 == 0){
      colorTop = 255;
      buttonTop = false;
      countRight = 0;
      countLeft = 0;
      countBottom = 0;
    }
    console.log("top pressed " + countTop);
  }

  if (mouseX > 544 && mouseX < 680 && mouseY >195 && mouseY < 269) {
    countRight++;
    if (countRight % 2 == 1 && buttonTop == false && buttonBottom == false && buttonLeft == false){
      colorRight = 40;
      buttonRight = true;
    } else if (countRight % 2 == 0){
      colorRight = 255;
      buttonRight = false;
      countLeft = 0;
      countTop = 0;
      countBottom = 0;
    }
    console.log("right pressed " + countRight);
  }

  if (mouseX > 330 && mouseX < 570 && mouseY >239 && mouseY < 313) {
    countBottom++;
    if (countBottom % 2 == 1 && buttonTop == false && buttonRight == false && buttonLeft == false){
      colorBottom = 40;
      buttonBottom = true;
    } else if (countBottom % 2 == 0){
      colorBottom = 255;
      buttonBottom = false;
      countRight = 0;
      countTop = 0;
      countLeft = 0;
    }
    console.log("bottom pressed " + countBottom);
  }

  if (mouseX > 140 && mouseX < 240 && mouseY > 400 && mouseY < 500) {
    personOneClick++;
    if (personOneClick % 2 == 1 && personTwo == false && light == false && vibe == false ){
      personOneColor = 100;
      personOne = true;
    } else if (personOneClick % 2 == 0){
      personOneColor = 255;
      personOne = false;
      personTwoClick = 0;
      lightClick = 0;
      vibeClick = 0;
    }
    console.log("Person One clicked: " + personOneClick);
  }

  if (mouseX > 315 && mouseX < 415 && mouseY > 400 && mouseY < 500) {
    personTwoClick++;
    if (personTwoClick % 2 == 1 && personOne == false && light == false && vibe == false ){
     personTwoColor = 100;
     personTwo = true;
   } else if (personTwoClick % 2 == 0){
     personTwoColor = 255;
     personTwo = false;
     personOneClick = 0;
     lightClick = 0;
     vibeClick = 0;
   }
   console.log("Person Two clicked: " + personTwoClick);
 }

  if (mouseX > 480 && mouseX < 580 && mouseY > 400 && mouseY < 500) {
    lightClick++;
    if (lightClick % 2 == 1 && personTwo == false && personOne == false && vibe == false ){
      lightColor = 100;
      light = true;
    } else if (lightClick % 2 == 0){
      lightColor = 255;
      light = false;
      personOneClick = 0;
      personTwoClick = 0;
      vibeClick = 0;
    }
    console.log("Light clicked: " + lightClick);
  }

  if (mouseX > 645 && mouseX < 745 && mouseY > 400 && mouseY < 500) {
    vibeClick++;
    if (vibeClick % 2 == 1 ){ //&& personTwo == false && personOne == false && light == false
      vibeColor = 100;
      vibe = true;
    } else if (vibeClick % 2 == 0){
      vibeColor = 255;
      vibe = false;
      personOneClick = 0;
      personTwoClick = 0;
      lightClick = 0;
    }
    console.log("Vibe clicked: " + vibeClick);
  }
}










//-----SERIAL FUNCTIONS-----

function printList(portList) {
  for (var i = 0; i < portList.length; i++) {
    print(i + " " + portList[i]);
  }
}

function serverConnected() {
  // print('serverConnected');
}

function portOpen() {
  // print('portOpen');
}

function gotData() {
  var stringRead = serial.readLine();  // read the incoming string
  trim(stringRead);                    // remove any trailing whitespace
  if (!stringRead) return;             // if the string is empty, do no more
  console.log(stringRead);             // println the string
  // latestData = stringRead;            // save it for the draw method

        // var aString = latestData.split(",");
        // if (aString.length>5)
        // {
        //   aNum = aString[1];
        //   aOff = aString[3];
        //   aSize = aString[5];
        // }
  // console.log("aNum: " + aNum + "aOff: " + aOff + "aSize: " + aSize);
}

function serialError(err) {
  // print('serialError ' + err);
}

function portClose() {
  // print('portClose');
}
